! tutor.h, libreria per suggerimenti nel corso dell'avventura
!          (implementazione ad oggetti)
!          Paolo Lucchesi, 2003
!
! ------------------------------------------------------------------------------
!
! Per usare il tutor:
!   - Mettete il comando < Include "tutorobj"; > immediatamente dopo
!     < Include "replace"; >
!
!   - Definite dopo < Include "grammar.h"; > questa riga:
!         Verb meta 'tutor' 'guida' * -> Tutor;
!
!   - Definite in ogni oggetto interessato la proprieta' tutor: una stringa di
!     istruzioni o una routine embedded. Se La routine restituisce true, il
!     tutor per quell'oggetto non verra' piu' invocato.
!
!   - Chiamate la funzione DoTutor(oggetto) per stampare le istruzioni relative
!     ad un certo oggetto.
!
!   - In alternativa chiamate la funzione DoTutor(oggetto, stringa) per
!     stampare la stringa di istruzioni, senza bisogno di definire la
!     proprieta' tutor. In questo caso verranno sempre ignorate ulteriori
!     chiamate relative a quell'oggetto.
!
! ------------------------------------------------------------------------------
!
! Questo file e' public domain, e puo' essere usato liberamente e senza alcun
! obbligo.
! Questo file e' distribuito senza alcuna garanzia. L'autore non puo' essere
! ritenuto responsabile per danni derivati dal suo uso.
!
! ------------------------------------------------------------------------------

Attribute tutored;
Global tutorflag=true;

[ DoTutor id str;
    if (~~tutorflag) rfalse;
    if (id has tutored) rfalse;
    if (str<=0 && (~~(id provides tutor))) rfalse;
    style underline;
    ! print "^[", (string) id.tutor, "]^^";
    print "^";
    if (str>0)   { 
        print (string) str; 
        give id tutored;
    }
    else        
        if (id.tutor()) give id tutored;
    print "^";
    style roman;
    rtrue;
];
    
[TutorSub;
    if (tutorflag) {
        tutorflag = false;
        "Il Tutor ora @`e disattivato.";
    }
    tutorflag = true;
    "Il Tutor ora @`e attivo.";
];

Object tutorobjdummy
    with tutor "Tutor dummy";
