!-----------------------------------------------------------------------------
! Magic And Fight System
! For INFORM compiler and Z-Machine text based Adventure games
!-----------------------------------------------------------------------------
!  Author: Giancarlo Niccolai
!  Version: 1.3
!  Last Revised: 2002-11-24
!  Contact author at: giancarlo@niccolai.ws
!  Feel free to use and distribute this file, but please report me if
!  you intend to change it (in better), so we can upgrade together
!
!  Released under GPL 2.0, or any later version at your will
!
!-----------------------------------------------------------------------------
!  Include this lib to have all MFS ready to use
!-----------------------------------------------------------------------------

! basic utility libs
include "MFS_Global.h";
include "MFS_Pronouns.h";
include "MFS_Damage.h";
! utilities
include "MFS_Follow.h";
include "MFS_Sky.h";
include "MFS_TopicParse.h";
include "MFS_Speech.h";
include "MFS_Tale.h";
include "MFS_Wander.h";
! basic libs
include "MFS_Magic.h";
include "MFS_War.h";
! spells and objects
include "MFS_MagicDevice";
include "MFS_SpellWriteable.h";
include "MFS_MagicObjects.h";
include "MFS_StandardSpells.h";
include "MFS_AttackSpells.h";
! complex objects
include "MFS_WarMage.h";

!Special Verbs
include "MFS_SpecialVerbs.h";

!After all obhects have been included, 
! remember to include the GRAMMAR in your file

! end of MFS.h
