!-----------------------------------------------------------------------------
! Magic And Fight System --- Tale
! For INFORM compiler and Z-Machine text based Adventure games
!-----------------------------------------------------------------------------
!  Author: Giancarlo Niccolai
!  Version: $Id: MFS_Tale.h,v 1.2 2003/11/18 07:59:27 gian Exp $
!  Contact author at: giancarlo@niccolai.ws
!  Feel free to use and distribute this file, but please report me if
!  you intend to change it (in better), so we can upgrade together
!
!  Released under GPL 2.0, or any later version at your will
!
!-----------------------------------------------------------------------------
! Tales - a way to make your adventure more appealing.
!-----------------------------------------------------------------------------

Ifndef Tale;

Include "MFS_Knowledge.h";

Class Tale
class Knowledge,
with
   name 'storia' 'storie' 'leggenda' 'leggende',
   title "Una storia",
   know_string "Ora conosci una storia",

   notify [ comment ;
      if ( self has known_about ) rtrue;

      give self known_about;
      if ( comment ~= nothing )
         Notice( comment );
      else
         Notice( self.know_string );
   ],

   explain [;
      style bold;
      print "^";
      print (string) self.title;
      print  "^^";
      style roman;

      if ( self.description ofclass Routine )
         self.description();
      else
         print (string) self.description;
      "^";
   ],
   has female;

Endif;

